#include <conio.h>
#include <stdio.h>
#include "gamegrid.h"
#include "paint.h"

void paintBox(int StartColumn, int ShadowStart, int ShadowEnd, int GridHeight, int GridWidth)
{
 int column,row;

 textcolor(6);

 gotoxy(StartColumn-1, 2); 
 for( column = 0; column <= GridWidth+1; column++)
 {
  cprintf("%c", 178);
 } 

 gotoxy(StartColumn-1, GridHeight+2);
 for( column = 0; column <= GridWidth+1; column++)
 {
  if(column >= ShadowStart && column <= ShadowEnd) cprintf("%c", 176);
  else cprintf("%c", 178);
 }
 
 for( row = 1; row < GridHeight; row++)
 {
  gotoxy(StartColumn-1, row+2);
  cprintf("%c\n", 178);
  gotoxy(GridWidth+StartColumn, row+2);
  cprintf("%c", 178);
 } 
}

void paint(GameGrid Tetris, int StartColumn)
{
 int row, column;
 int ShadowStart, ShadowEnd;

 ShadowStart = Tetris.GridWidth*2;
 ShadowEnd = 0;

 for( row = 1; row < Tetris.GridHeight; row++)
 {
  for( column = 0; column < Tetris.GridWidth*2; column+=2)
  {
   gotoxy(column+StartColumn, row+2);
   if(Tetris.BlockArray[row][column/2][2] == 0) textcolor(Tetris.CurrentColour);
   else textcolor(Tetris.BlockArray[row][column/2][2]);
   if((Tetris.BlockArray[row][column/2][0] == 1) ||
      (Tetris.BlockArray[row][column/2][1] == 1))
   cprintf("%c%c", 219,219);
   else cprintf("  ");
   if(Tetris.BlockArray[row][column/2][0] == 1)
   {
    if(column < ShadowStart) ShadowStart = column;
    if(column > ShadowEnd) ShadowEnd = column;
   }
  }		
 }

 paintBox(StartColumn, ShadowStart+1, ShadowEnd+2, Tetris.GridHeight, Tetris.GridWidth*2);

 textcolor(15);
 gotoxy(StartColumn+22, 7);
 cprintf("Level %d  ", Tetris.CurrentLevel);
 gotoxy(StartColumn+22, 6);
 cprintf("Lines %d  ", Tetris.LinesClear);
 gotoxy(StartColumn+22, 5);
 cprintf("Score %d  ", Tetris.Score);

 gotoxy(StartColumn+24, 10);
 cprintf("Next");

 for( row = 0; row < 4; row++)
 {
   for( column = 0; column < 8; column+=2)
   {
    gotoxy(StartColumn+22+column, 12+row);
    textcolor((Tetris.NextPiece.Colour + Tetris.CurrentLevel) % 15 + 1);
    if(row >= Tetris.NextPiece.ArraySize || column/2 >= Tetris.NextPiece.ArraySize) cprintf("  ");
    else if(Tetris.NextPiece.PieceArray[row][column/2] == 1) cprintf("%c%c", 219,219);
    else cprintf("  ");
   }
 }
}

void paintPoints(int Points, int StartColumn, int TotalPoints)
{
 while(TotalPoints > 0)
 {
  gotoxy(StartColumn+32-TotalPoints, 17);
  if(Points > 0) textcolor(13);
  else textcolor(8);
  cprintf("%c", 14);
  TotalPoints--;
  Points--;
 }
}
