#include <stdlib.h>
#include "raceq.h"

/*
The stdlib is for malloc and free.  Since I'm dealing with pointers, I no longer have the
luxury of not f&cking with the memory of the machine.  Hurray for memory leaks; I hope I
caught all of them.
*/

//This is pretty straightforward. NULL means that there is no stored value to be found.
int isEmpty(RaceQ theQ)
{
 if(theQ.head != NULL) return 0;
 else return 1;
}

/*
I add the value to the end of the queue.  Or the beginning and the end if it happens to
be the only element in the queue so far.  For the uninitiated, a queue is first in, first
out.
*/
RaceQ enqueue(RaceQ theQ, int Value)
{
 QNode* newNode = malloc(sizeof(newNode));  //Make sure we make enough space for the next one.
 
 newNode->RandomValue = Value;
 newNode->next = NULL; 
 	
 if (theQ.head == NULL)
 {
  theQ.head = newNode;
  theQ.head->next = NULL;
  theQ.tail = theQ.head;
  theQ.tail->next = NULL;
 }
 else
 {
  theQ.tail->next = newNode;
  theQ.tail = newNode;
  theQ.tail->next = NULL;
 }

 return theQ;
}

//If you're REALLY curious about the function here, just check the h file.
int HeadValue(RaceQ theQ)
{
 return theQ.head->RandomValue;
}

//Remove the element from the front and make the next one the front of the queue.
//We free() the element in order to return the memory used by malloc from before.
RaceQ dequeue(RaceQ theQ)
{
 QNode* newNode = theQ.head;
 theQ.head = theQ.head->next;
 free(newNode);

 return theQ;
}

//Call dequeue until the queue is empty.
RaceQ freeQ(RaceQ theQ)
{
 while(!isEmpty(theQ))
   theQ = dequeue(theQ);

 return theQ;
}

/*

This was the test driver, so ignore it.

int main()
{
 RaceQ Q1;
 Q1 = enqueue(Q1, 1);
 Q1 = enqueue(Q1, 4);
 if(isEmpty(Q1)) printf("NO!");
 else printf("Here it is: %d", HeadValue(Q1));
 Q1 = dequeue(Q1);
 if(isEmpty(Q1)) printf("NO!");
 else printf("Here it is: %d", HeadValue(Q1));
 freeQ(Q1);
 return 0;
}
*/
